#include "User.h"


User::~User()
{
  std::map<unsigned int, std::map<unsigned int, std::vector<operation> >* >::iterator it;

  for (it = _operations.begin(); it != _operations.end(); it++)
    {
      if (_operations[it->first])
	{
	  delete it->second;
	}
    }
}

struct category User::GetCategory(wxString catId)
{
  struct category cat;
  std::vector<category>::iterator it;

  for (it=_categories.begin(); it !=_categories.end(); it++)
    if (it->id == catId)
      return *it;

  cat.id = _("0");
  cat.parent = _("0");
  cat.name = _("Unknown");
  cat.font = _("");
  cat.color = wxColour(0xFF, 0xFF, 0xFF);

  return cat;
}

wxString User::GetCategoryName(wxString catId)
{
  std::vector<category>::iterator it;
  for (it=_categories.begin(); it !=_categories.end(); it++)
    if (it->id == catId)
      return it->name;

  return _("Unknown") ;
}

wxString User::GetCategoryId(wxString catName)
{
  std::vector<category>::iterator it;
  for (it=_categories.begin(); it !=_categories.end(); it++)
    if (it->name == catName)
      return it->id;

    return _("0") ;
}

wxString User::GetAccountName(wxString accountId)
{
    std::vector<Account>::iterator it;
    for (it=_accounts.begin(); it !=_accounts.end(); it++)
	if (it->id == accountId)
	    return it->name;

    return _("Unknown") ;
}

wxString User::GetAccountId(wxString accountName)
{
    std::vector<Account>::iterator it;
    for (it=_accounts.begin(); it !=_accounts.end(); it++)
	if (it->name == accountName)
	    return it->id;

    return _("0") ;
}

int User::GetCategoriesNumber()
{
  return _categories.size();
}

int User::GetAccountsNumber()
{
  return _accounts.size();
}

int User::GetOperationsNumber(int month, int year)
{
  return (*_operations[year])[month].size();
}
